from dbpool import getConnection
from heroes_mock import HEROES

def get_heroes():
#    if HEROES:
#        return HEROES
#    else:
#        return 'No heroes available', 404
    try:
        dbh = getConnection()
        heroes = []
        cur = dbh.cursor()
        cur.execute("SELECT id, name FROM hero")
        for (id, name) in cur:
            heroes.append({"id": id, "name": name})
        return heroes
    except Exception:
        return 500, str(Exception)
    finally:
        dbh.close()


def get_hero(id=None):
    try:
        hero = next(x for x in HEROES if x["id"] == id)
        return { "id": hero["id"], "name": hero["name"] }
    except StopIteration:
        return 'Hero not found', 404
    
def put_hero(id=None, hero=None):
    try:
        heroToUpdate = next(x for x in HEROES if x["id"] == id)
        checkNewName = next((x for x in HEROES if x["name"] == hero["name"]), None)
        if (checkNewName):
            return 'Duplicate name', 403
        heroToUpdate["name"] = hero["name"]
        return 'Hero updated', 200
    except StopIteration:
        return 'Hero not found', 404
    except Exception:
        return 'Some error', 403

def post_hero(hero=None):
    try:
        newHeroId = len(HEROES)
        hero["id"] = newHeroId
        HEROES.append(hero)
        return 'Hero inserted', 201
    except Exception:
        return 'Some error', 403
